package com.liquidnet.client.admin.zhengzai.smile.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

@ApiModel(value = "UserDataAgentVo", description = "用户单票数据")
@Data
public class UserDataAgentVo implements Serializable, Cloneable{

    /**
     * 票提id
     */
    @ApiModelProperty(value = "票提id", example = "")
    private String ticketsId;

    /**
     * 票名称
     */
    @ApiModelProperty(value = "票名称", example = "")
    private String ticketName;

    /**
     * 数量
     */
    @ApiModelProperty(value = "售出张数", example = "")
    private BigDecimal number;

    /**
     * 单价
     */
    @ApiModelProperty(value = "单价", example = "")
    private BigDecimal price;

    /**
     * 单价
     */
    @ApiModelProperty(value = "真实付款金额", example = "")
    private BigDecimal priceReal;

    /**
     * 票提
     */
    @ApiModelProperty(value = "票提", example = "")
    private BigDecimal agent;

    /**
     * 提成
     */
    @ApiModelProperty(value = "提成", example = "")
    private BigDecimal commission;




    /**
     * 实际销售金额 实际支付金额-快递费=提成基数
     */
    @ApiModelProperty(value = "实际销售金额", example = "")
    private BigDecimal realTotalPrice;
    /**
     * 优惠券金额
     */
    @ApiModelProperty(value = "优惠券金额", example = "")
    private BigDecimal voucherPrice;



    /**
     * 票面金额
     */
    @ApiModelProperty(value = "票面金额", example = "")
    private BigDecimal faceTotalPrice;

    /**
     * 快递费总金额
     */
    @ApiModelProperty(value = "快递费总金额", example = "")
    private BigDecimal totalPriceExpress;

    /**
     * 票提
     */
    @ApiModelProperty(value = "票提", example = "")
    private BigDecimal agentDistributions;

    private static final UserDataAgentVo obj = new UserDataAgentVo();

    public static UserDataAgentVo getNew() {
        try {
            return (UserDataAgentVo) obj.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
        }
        return new UserDataAgentVo();
    }
}
